<?php 
/**
 * Система управления сайтом HostCMS v. 5.xx
 * Copyright © 2005-2010 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 *
 * Ajax загрузчик формы списка ip-адресов.
 * 
 * Файл: /admin/ip/action/load_ip.php
 * 
 * @author Hostmake LLC
 * @version 5.x
 */
function LoadAjaxData(&$admin_forms)
{
	$on_page = $admin_forms->GetOnPageCount();	$page = to_int($_REQUEST['limit']);
	$begin = ($page == 0) ? 0 : ($page - 1) * $on_page;

	$param = array();

	$param['limit'][0] = array('begin' => $begin, 'count' => $on_page);

	// Выборка нужных записей.
	$param['data'][] = "SELECT *
	FROM ip_table WHERE 1
	{FILTER_STRING} {ORDER_STRING} {LIMIT}";

	// Число нужных записей.
	$count = "SELECT count(ip_id) AS count
	FROM ip_table WHERE 1
	{FILTER_STRING}";

	// Формируем верхнее меню.
	$k = 0;
	$menu = array();
	$menu[$k]['name'] = $GLOBALS['MSG_ip']['ip_main_menu'];
	$menu[$k]['link'] = '';
	$menu[$k]['icon'] = '';

	$p = 0;

	$sub_menu = array();
	$sub_menu[$p]['name'] = $GLOBALS['MSG_ip']['show_ip_link'];
	$sub_menu[$p]['link'] = $admin_forms->GetHtmlCallTrigerSingleAction('edit_ip', 'check_0_0', 25, 0, 0);
	$sub_menu[$p]['onclick'] = $admin_forms->GetOnClickCallTrigerSingleAction('edit_ip', 'check_0_0', 25, 0, 0);
	$sub_menu[$p]['icon'] = '/admin/images/ip_add.gif';

	// Добавляем подэлементы.
	$menu[$k]['sub_items'] = $sub_menu;

	// Формируем массив меню.
	$menu_array = array();

	$menu_array[] = $menu;

	$param['field_params'][0]['ip_deny_access']['admin_forms_field_type'] = 7;// картинка-ссылка
	$param['field_params'][0]['ip_deny_access']['admin_forms_field_link'] = $admin_forms->GetHtmlCallTrigerSingleAction('change_deny_access', 'check_0_{ip_id}', 25, 0, 0);
	$param['field_params'][0]['ip_deny_access']['admin_forms_field_onclick'] = $admin_forms->GetOnClickCallTrigerSingleAction('change_deny_access', 'check_0_{ip_id}', 25, 0, 0);

	$param['field_params'][0]['ip_no_statistic']['admin_forms_field_type'] = 7;// картинка-ссылка
	$param['field_params'][0]['ip_no_statistic']['admin_forms_field_link'] = $admin_forms->GetHtmlCallTrigerSingleAction('change_no_statistic', 'check_0_{ip_id}', 25, 0, 0);
	$param['field_params'][0]['ip_no_statistic']['admin_forms_field_onclick'] = $admin_forms->GetOnClickCallTrigerSingleAction('change_no_statistic', 'check_0_{ip_id}', 25, 0, 0);

	$param['total_count'][] = $count;
	$param['current_page'] = $page;
	$param['on_page'] = $on_page;
	$param['menus'] = $menu_array;

	$param['title'] = $GLOBALS['MSG_ip']['show_ip_title'];

	return $param;
}

/**
 * Функция удаления IP-адреса
 *
 * @param array $param
 */
function delete_ip(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$ip = & singleton('ip');

		$count = 0;

		if (isset($param['data']))
		{
			foreach ($param['data'] as $dataset)
			{
				foreach ($dataset as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					// Определяем информацию об объекте
					$object_res = $ip->SelectIp($key);

					if (mysql_num_rows($object_res) == 1)
					{
						if ($object_res)
						{
							$object_row = mysql_fetch_assoc($object_res);
						}

						if ($object_row)
						{
							$object_user_id = $object_row['users_id'];
						}
						else
						{
							$object_user_id = 0;
						}
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						if (!$ip->DelIp($key))
						{
							$flag_success = false;
						}
						else
						{
							$count++;
							$flag_success = true;
						}
					}
					else
					{
						$user_access->MessageOnlyOwn();
						$flag_success = false;
					}
				}
			}
			if ($flag_success)
			{
				if ($count == 1)
				{
					show_message($GLOBALS['MSG_ip']['ip_delete_success_message']);
				}
				else
				{
					show_message($GLOBALS['MSG_ip']['ips_delete_success_message']);
				}
			}
			else // Ошибка удаления ip-адреса
			{
				show_error_message($GLOBALS['MSG_ip']['ip_delete_error_message']);
			}
		}
	}

	$param['error'] = ob_get_clean();
}

/**
 * Редактирование адреса
 *
 * @param array $param
 * @return boolean
 */
function edit_ip(&$param)
{
	ob_start();

	if (isset($param['data']))
	{
		foreach ($param['data'] as $dataset)
		{
			foreach ($dataset as $edit_ip => $value)
			{
				// Определяем режим доступа пользователя и принадлежит ли объект пользователю
				$user_access = new user_access();

				$ip = new ip();

				// Определяем информацию об объекте
				$object_res = $ip->SelectIp($edit_ip);

				if (mysql_num_rows($object_res) == 1)
				{
					if ($object_res)
					{
						$object_row = mysql_fetch_assoc($object_res);
					}

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}
				}
				else
				{
					$object_user_id = 0;
				}

				if ($user_access->IssetUserAccessForObject($object_user_id))
				{
					include(CMS_FOLDER . 'admin/ip/action/form_edit_add_ip.php');
					$param['title'] = $edit_ip == 0 ? $GLOBALS['MSG_ip']['ip_add_form_title'] : $GLOBALS['MSG_ip']['ip_edit_form_title'];
					break;
				}
				else
				{
					$user_access->MessageOnlyOwn();
					$param['error'] = ob_get_clean();
					return ;
				}
			}
		}
	}

	$param['result'] = ob_get_clean();
	return true;
}

/**
 * Изменение прав доступа
 *
 * @param array $param
 */
function change_deny_access(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{

		$DataBase = &singleton('DataBase');

		if (isset($param['data']) && isset($param['data'][0]))
		{
			foreach ($param['data'][0] as $ip_id => $value)
			{
				// Определяем режим доступа пользователя и принадлежит ли объект пользователю
				$user_access = new user_access();

				$ip = new ip();

				// Определяем информацию об объекте
				$object_res = $ip->SelectIp($ip_id);

				if (mysql_num_rows($object_res) == 1)
				{
					if ($object_res)
					{
						$object_row = mysql_fetch_assoc($object_res);
					}

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}
				}
				else
				{
					$object_user_id = 0;
				}

				if ($user_access->IssetUserAccessForObject($object_user_id))
				{
					$ip_id = intval($ip_id);
					
					// Инвертируем
					$query = "UPDATE `ip_table`
					SET `ip_deny_access` = 1 - `ip_deny_access`
					WHERE `ip_id` = '$ip_id'";

					$DataBase->query($query);
				}
				else
				{
					$user_access->MessageOnlyOwn();
				}
			}
		}
	}

	$param['error'] = ob_get_clean();
}

/**
 * Регистрация в статистике
 *
 * @param array $param
 */
function change_no_statistic(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$DataBase = &singleton('DataBase');

		if (isset($param['data']) && isset($param['data'][0]))
		{
			foreach ($param['data'][0] as $ip_id => $value)
			{
				// Определяем режим доступа пользователя и принадлежит ли объект пользователю
				$user_access = new user_access();

				$ip = new ip();

				// Определяем информацию об объекте
				$object_res = $ip->SelectIp($ip_id);

				if (mysql_num_rows($object_res) == 1)
				{
					if ($object_res)
					{
						$object_row = mysql_fetch_assoc($object_res);
					}

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}
				}
				else
				{
					$object_user_id = 0;
				}

				if ($user_access->IssetUserAccessForObject($object_user_id))
				{
					$ip_id = intval($ip_id);

					// Инвертируем
					$query = "UPDATE `ip_table` SET `ip_no_statistic` = 1 - `ip_no_statistic`
							WHERE `ip_id` = '$ip_id'";

					$DataBase->query($query);
				}
				else
				{
					$user_access->MessageOnlyOwn();
				}
			}
		}
	}

	$param['error'] = ob_get_clean();
}

?>